/* AddIn INI-key deinstallation script, by Michael L. Semon (mlsemon@gate.net) June 19, 1998 */
/* This script adds INI entries for Mesa 2 AddIns. */
rc = RxFuncAdd("SysIni","RexxUtil","SysIni")
rc = RxFuncAdd("SysGetKey","RexxUtil","SysGetKey")

SAY ""
TestedKey = ""
ExitCond = 0
a = 0
GetKeyIsNecessary = 1

DO WHILE ExitCond = 0
    /* find the next key and query it */
    a = a + 1
    presentAddInKey = "AddIn " || a
    TestedKey.a = TRANSLATE(SysIni("mesa2.ini","Mesa2",presentAddInKey))

    /* report the next available AddIn; flag to skip the (y|n) sequence if no keys found */
    IF TestedKey.a = "ERROR:" & a = 1 THEN
        GetKeyIsNecessary = 0

    IF TestedKey.a = "ERROR:" THEN
            ExitCond = 1
    ELSE
        DO
            IF a = 1 THEN
                SAY "The following Mesa 2 AddIns are registered:"

            SAY OVERLAY(a || ":", "     ") || TestedKey.a
        END
END /* do */

IF GetKeyIsNecessary THEN
    DO
        SAY ""
        SAY "Choose a valid number to delete a key, or press q to quit."
        Answer = SysGetKey()
        SAY ""
    END
ELSE
    DO
        Answer = "q"
        SAY "There are no AddIn keys registered."
    END

IF DATATYPE(Answer) = "NUM" then
    IF (Answer > 0) & (Answer <= a) THEN
        DO
            DO b = Answer TO (a - 1)
               presentAddInKey = "AddIn " || b
               c = b + 1
               rc = SysIni("mesa2.ini","Mesa2",presentAddInKey, TestedKey.c)
               IF rc \= "" THEN
                    SAY "The key of AddIn " || c || " could not be copied to the AddIn " || b || " key."
            END /* do */

            presentAddInKey = "AddIn " || a
            rc = SysIni("mesa2.ini","Mesa2",presentAddInKey)
            IF rc \= "ERROR:" THEN
                DO
                    rc = SysIni("mesa2.ini","Mesa2",presentAddInKey,"DELETE:")
                    IF rc \= "" THEN
                        SAY "The final AddIn key could not be deleted."
                END

        a = 0
        ExitCond = 0
        DO WHILE ExitCond = 0
            /* find the next key and query it */
            a = a + 1
            presentAddInKey = "AddIn " || a
            TestedKey.a = TRANSLATE(SysIni("mesa2.ini","Mesa2",presentAddInKey))
        
            /* report the next available AddIn; give the option to register it */
            IF TestedKey.a = "ERROR:" & a = 1 THEN
                SAY "There are no AddIn keys registered."
        
            IF TestedKey.a = "ERROR:" THEN
                    ExitCond = 1
            ELSE
                DO
                    IF a = 1 THEN
                        SAY "The following Mesa 2 AddIn keys are left:"
        
                    SAY OVERLAY(a || ":", "     ") || TestedKey.a
                END
        END
END /* do */