#define INCL_WIN
#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#include <os2.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "range.h"
#include "model.h"

#include "data.h"

#include "addin.h"
#include "extaddin.h"
#include "sampadin.h"

extern HWND *theDataHwnds;
extern AddIn *thisAddIn;
extern int dataCount;


// the data needed in the goal seeker.
struct _dataData {
    Model *md;
    DataFilter *sp;
};


// this is the procedure that processes the "goal seeker" Dialog
MRESULT EXPENTRY DataDlgProc(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
    MRESULT ret = (MRESULT) 0L;
    _dataData *sd = (_dataData *)WinQueryWindowULong(hwnd,QWL_USER);
    char buffer[250];
    int tmp, x;

    switch (msg) {
    case WM_INITDLG:
        {
            x = 0;  // add itself to the array of hwnds
            while (x < dataCount && theDataHwnds[x]) {
                x++;
            } /* endwhile */

            if (x == dataCount) {
                dataCount *= 2;
                theDataHwnds = (HWND *)SysMRealloc(theDataHwnds,dataCount*sizeof(HWND));
            } /* endif */

            theDataHwnds[x] = hwnd;

            sd = new _dataData;
            
            WinSetWindowULong(hwnd,QWL_USER,(ULONG) sd);
            sd -> md = new Model(-1);
            sd -> sp = NULL;

            Range rng = thisAddIn -> getCurrentRange();
            Address ad = thisAddIn -> getCurrentAddress();

            if (! sd -> md -> getBlob("DATA_FILTER_TABLE",250,buffer))
                sd -> md -> rangeToString(rng,buffer,250);
            if (buffer[0] == 0) {
                sd -> md -> addressToString(ad,buffer,250);
            } // endif
            WinSetDlgItemText(hwnd,DID_DF_TABLE,buffer);
            if (! sd -> md -> getBlob("DATA_FILTER_CRITERIA",250,buffer))
                sd -> md -> rangeToString(rng,buffer,250);
            if (buffer[0] == 0) {
                sd -> md -> addressToString(ad,buffer,250);
            } // endif
            WinSetDlgItemText(hwnd,DID_DF_CRITERIA,buffer);
            if (! sd -> md -> getBlob("DATA_FILTER_DESTINATION",250,buffer))
                sd -> md -> addressToString(ad,buffer,250);
            WinSetDlgItemText(hwnd,DID_DF_DESTINATION,buffer);



            sd -> md -> getName(buffer,100);
            WinSetDlgItemText(hwnd,DID_MODELNAME,buffer);
        }
        break;
    case WM_DONEFILTER:
        {
            if (sd && sd -> sp) {
                delete sd -> sp;
                sd -> sp = NULL;
            } // endif
            WinEnableWindow(WinWindowFromID(hwnd,DID_DF_STOP),FALSE);
            WinEnableWindow(WinWindowFromID(hwnd,DID_OK),TRUE);
            WinEnableWindow(WinWindowFromID(hwnd,DID_CANCEL),TRUE);
            WinEnableWindow(WinWindowFromID(hwnd,DID_DF_TABLE),TRUE);
            WinEnableWindow(WinWindowFromID(hwnd,DID_DF_CRITERIA),TRUE);
            WinEnableWindow(WinWindowFromID(hwnd,DID_DF_DESTINATION),TRUE);
        }
        break;
    case WM_COMMAND:
        switch (LOUSHORT(mp1)) {
        case DID_DF_STOP:
            {
                if (sd && sd -> sp) {
                    sd -> sp -> stop();
                } // endif
            }
            break;
        case DID_OK:
            {
                DataFilter *filter = new DataFilter(sd -> md,hwnd);

                char *table = (char *)SysMMalloc(256);
                char *criteria = (char *)SysMMalloc(256);
                char *destination = (char *)SysMMalloc(256);
                char *script = (char *)SysMMalloc(1000);

                WinQueryDlgItemText(hwnd,DID_DF_TABLE,250,table);
                sd -> md -> setBlob("DATA_FILTER_TABLE",strlen(table)+1,table);
                filter -> setTable(sd -> md -> stringToRange(table));

                WinQueryDlgItemText(hwnd,DID_DF_CRITERIA,250,criteria);
                sd -> md -> setBlob("DATA_FILTER_CRITERIA",strlen(criteria)+1,criteria);
                filter -> setCriteria(sd -> md -> stringToRange(criteria));

                WinQueryDlgItemText(hwnd,DID_DF_DESTINATION,250,destination);
                sd -> md -> setBlob("DATA_FILTER_DESTINATION",strlen(destination)+1,destination);
                filter -> setOutput(sd -> md -> stringToRange(destination));

                sprintf(script,"DATAFILTER(\"%s\",\"%s\",\"%s\")",table,criteria,destination);
                thisAddIn -> addStringToHistory(script);

                SysMFree(table);
                SysMFree(criteria);
                SysMFree(destination);
                SysMFree(script);

                if (filter -> doFilter()) {
                    sd -> sp = filter;
                    WinEnableWindow(WinWindowFromID(hwnd,DID_DF_STOP),TRUE);
                    WinEnableWindow(WinWindowFromID(hwnd,DID_OK),FALSE);
                    WinEnableWindow(WinWindowFromID(hwnd,DID_CANCEL),FALSE);
                    WinEnableWindow(WinWindowFromID(hwnd,DID_DF_TABLE),FALSE);
                    WinEnableWindow(WinWindowFromID(hwnd,DID_DF_CRITERIA),FALSE);
                    WinEnableWindow(WinWindowFromID(hwnd,DID_DF_DESTINATION),FALSE);
                } else {
                    delete filter;
                } // endif
            }
            break;
        default:
            ret = WinDefDlgProc(hwnd,msg,mp1,mp2);
            break;
        } /* endswitch */
        break;
    case WM_GETMODELPTR:
        return (MPARAM)sd -> md;
        break;
    case WM_CLOSE:
        if (sd -> sp) return 0;
        for (x = 0; x < dataCount ; x++) {   // remove from the hwnd Array
            if (theDataHwnds[x] == hwnd) {
                theDataHwnds[x] = NULL;
            } /* endif */
        } /* endfor */
        if (sd -> md) {
            delete sd -> md;
        } /* endif */
        delete sd;
        WinDismissDlg(hwnd,DID_OK);
        break;
    default:
        ret = WinDefDlgProc(hwnd,msg,mp1,mp2);
        break;
    } /* endswitch */

    return ret;
}
void _Optlink dataThread(void *d)
{
    DataFilter *sp = (DataFilter *)d;
    sp -> doFilter2();
    if (sp -> getHWND()) {
        WinPostMsg(sp -> getHWND(),WM_DONEFILTER,0,0);
    } // endif
}

int DataFilter :: doFilter()
{
    Address critul,critlr;
    criteria.getItem(0,critul,critlr);
    if (critlr.isNull() || critul.row() == critlr.row()) {
        WinMessageBox(HWND_DESKTOP,hwnd,"Invalid criteria range.  Must have at least two rows. (Title in top row)","Error",1,MB_CANCEL|MB_ERROR|MB_APPLMODAL);
        return 0;
    } // endif
    Address srcul,srclr;
    table.getItem(0,srcul,srclr);
    if (srclr.isNull() || srcul.row() == srclr.row()) {
        WinMessageBox(HWND_DESKTOP,hwnd,"Invalid table range.  Must have at least two rows. (Title in top row)","Error",1,MB_CANCEL|MB_ERROR|MB_APPLMODAL);
        return 0;
    } // endif

    _beginthread(dataThread,(int) NULL,1024*48,(void *)this);


    return 1;
}

int DataFilter :: doFilter2()
{
    Address critul,critlr;
    criteria.getItem(0,critul,critlr);

    if (critlr.isNull() || critul.row() == critlr.row()) {
        return 0;
    } // endif
    Address srcul,srclr;
    table.getItem(0,srcul,srclr);
    if (srclr.isNull() || srcul.row() == srclr.row()) {
        return 0;
    } // endif
    
    int x,y,z;
    Address outul,outlr;
    output.getItem(0,outul,outlr);
    char *buffer = (char *)SysMMalloc(256);
    char **tableTitles = (char **)SysMMalloc(sizeof(char*)*(srclr.col()-srcul.col()+1));
    for (x = srcul.col();x <= srclr.col(); x++) {
        tableTitles[x-srcul.col()] = (char *)SysMMalloc(256);
        model -> getCellOutput(Address(srcul.row(),x,srcul.layer()),
                               tableTitles[x-srcul.col()],256);
    } // endfor

    // load the criterias
    int numCriteria = (critlr.col()-critul.col()+1);
    int numCriteriaRows = (critlr.row()-critul.row());
    int *criteriaColMapping = (int *)SysMMalloc(sizeof(int)*numCriteria);
    MesaAddInValue *criterias = (MesaAddInValue *)SysMMalloc(sizeof(MesaAddInValue)*numCriteria*numCriteriaRows);
    for (x = critul.col();x <= critlr.col(); x++) {
        model -> getCellOutput(Address(critul.row(),x,critul.layer()),
                               buffer,256);
        criteriaColMapping[x-critul.col()] = -1;
        for (y = srcul.col();y <= srclr.col(); y++) {
            if (!strcmp(tableTitles[y-srcul.col()],buffer)) {
                criteriaColMapping[x-critul.col()] = y-srcul.col();
            } //endif
        } // endfor
        for (y = 0; y < numCriteriaRows; y++) {
            z = y*numCriteria+(x-critul.col());
            model -> initAddInValue(criterias[z]);
            if (criteriaColMapping[x-critul.col()] != -1) {
                model -> getCellValue(Address(y+critul.row()+1,x,critul.layer()),
                                      criterias[z]);
            } // endif
        } // endfor
    } // endfor
    for (z = 0; z < numCriteria; z++) {
        int hasValidCriteria = 0;
        for (y = 0; y < numCriteriaRows; y++) {
            if (criterias[y*numCriteria+z].type != errorValueMesaAddInType) {
                hasValidCriteria = 1;
            } else if (criterias[y*numCriteria+z].error != 0) {
                hasValidCriteria = 1;
            }
        } // endfor
        if (!hasValidCriteria) {
            criteriaColMapping[z] = -1;
        } // endif
    }

    int *outputColMapping = NULL;
    int numOutputCols = 0;
    if (outlr.isNull() || outlr == outul) {
        numOutputCols = (srclr.col()-srcul.col()+1);
        outputColMapping = (int *)SysMMalloc(sizeof(int)*numOutputCols);
        for (x = 0; x < (srclr.col()-srcul.col()+1); x++) {
            outputColMapping[x] = x;
        } // endfor
    } else {
        numOutputCols = (outlr.col()-outul.col()+1);
        outputColMapping = (int *)SysMMalloc(sizeof(int)*numOutputCols);
        for (x = outul.col();x <= outlr.col(); x++) {
            model -> getCellOutput(Address(outul.row(),x,outul.layer()),
                                   buffer,256);
            outputColMapping[x-outul.col()] = -1;
            for (y = srcul.col();y <= srclr.col(); y++) {
                if (!strcmp(tableTitles[y-srcul.col()],buffer)) {
                    outputColMapping[x-outul.col()] = y-srcul.col();
                }
            } // endfor
        } // endfor
    } // endif

    int numOutputValues = 0;
    int maxOutputValues = 50;
    int numOutputRows = 0;
    if (!(outlr.isNull() || outlr == outul)) {
        numOutputRows++;
    } // endif
    MesaAddInValue *values = (MesaAddInValue *)SysMMalloc(sizeof(MesaAddInValue)*maxOutputValues);

    for (x = srcul.row()+1;x <= srclr.row() && !doStop; x++) {
        int meetsCriterias = 0;
        for (y = 0; (y < numCriteriaRows) && !meetsCriterias; y++) {
            meetsCriterias = 1;
            for (z = 0; z < numCriteria; z++) {
                if (criteriaColMapping[z] != -1) {
                    MesaAddInValue thevalue;
                    model -> initAddInValue(thevalue);
        
                    model -> getCellValue(Address(x,
                                                  criteriaColMapping[z],
                                                  srcul.layer()),
                                          thevalue);
        
                    meetsCriterias &= meetsCriteria(&criterias[y*numCriteria+z],&thevalue);
        
                    model -> freeAddInValue(thevalue);
                } // endif
            } // endfor
        } // endfor

        // check mapping
        //if OK, output result
        if (meetsCriterias) {
            while ((numOutputValues+numOutputCols) >= maxOutputValues) {
                maxOutputValues *= 2;
                values = (MesaAddInValue *)SysMRealloc(values,sizeof(MesaAddInValue)*maxOutputValues);
            } // endif
            for (y = 0; y < numOutputCols; y++) {
                model -> initAddInValue(values[numOutputValues]);
                if (outputColMapping[y] != -1) {
                    model -> getCellValue(Address(x,outputColMapping[y],srcul.layer()),
                                          values[numOutputValues]);
                } // endif
                values[numOutputValues].row = outul.row()+numOutputRows;
                values[numOutputValues].column = outul.col()+y;
                values[numOutputValues].layer = outul.layer();
                numOutputValues++;
            } // endfor
            numOutputRows++;
        }
    } // endfor
    // blank the area
    while (numOutputRows < (outlr.row()-outul.row()) && !doStop) {
        while ((numOutputValues+numOutputCols) >= maxOutputValues) {
            maxOutputValues *= 2;
            values = (MesaAddInValue *)SysMRealloc(values,sizeof(MesaAddInValue)*maxOutputValues);
        } // endif
        for (y = 0; y < numOutputCols; y++) {
            model -> initAddInValue(values[numOutputValues]);
            values[numOutputValues].row = outul.row()+numOutputRows;
            values[numOutputValues].column = outul.col()+y;
            values[numOutputValues].layer = outul.layer();
            numOutputValues++;
        } // endfor
        numOutputRows++;
    } // endif

    if (numOutputValues && !doStop) {
        // save output to model
        model -> setCellValues(values,numOutputValues);
    } // endif
    for (x = 0; x < numOutputValues; x++) {
        model -> freeAddInValue(values[x]);
    } // endfor
    SysMFree(values);
    for (x = 0; x < (numCriteria*numCriteriaRows);x++) {
        model -> freeAddInValue(criterias[x]);
    } // endfor
    SysMFree(criterias);
    for (x = srcul.col();x <= srclr.col(); x++) {
        SysMFree(tableTitles[x-srcul.col()]);
    } // endfor
    SysMFree(tableTitles);
    SysMFree(criteriaColMapping);
    SysMFree(outputColMapping);
    SysMFree(buffer);

    return 1;
}


int DataFilter :: meetsCriteria(MesaAddInValue *criteria, MesaAddInValue *value)
{
    int numType = 1;
    double number,number2;
    int operation = 0;
    int stridx = 0;

    switch (criteria -> type) {
    case errorValueMesaAddInType:
        if (criteria -> error == 0) return 1;
        return 0;
    case stringValueMesaAddInType:
        {
            const char *tmp = criteria -> string;
            if (tmp[0] == '=') {
                stridx++;
            } else if (tmp[0] == '<') {
                stridx++;
                operation = -2;
                if (tmp[1] == '=') {
                    stridx++;
                    operation = -1;
                } // endif
            } else if (tmp[0] == '>') {
                stridx++;
                operation = 2;
                if (tmp[1] == '=') {
                    stridx++;
                    operation = 1;
                } // endif
            } // endif
            tmp += stridx;
            while (*tmp && numType) {
                if (!((*tmp >= '0' && *tmp <= '9') || *tmp == '.' || *tmp == ',')) {
                    numType = 0;
                } // endif
                tmp++;
            } // endwhile
            if (numType) {
                tmp = criteria -> string;
                tmp += stridx;
                number = atof(tmp);
            } // endif
        }
        break;
    case numberValueMesaAddInType:
        number = criteria -> number;
        break;
    default:
        return 0;
    } // endswitch

    if (numType) {
        switch (value -> type) {
        case errorValueMesaAddInType:
            return 0;
        case stringValueMesaAddInType:
            {
                const char *tmp = value -> string;
                int nt2 = 1;
                while (*tmp && nt2) {
                    if (!((*tmp >= '0' && *tmp <= '9') || *tmp == '.' || *tmp == ',')) {
                        nt2 = 0;
                    } // endif
                    tmp++;
                } // endwhile
                if (nt2) {
                    tmp = value -> string;
                    number2 = atof(tmp);
                } else {
                    return 0;
                } // endif
            }
            break;
        case numberValueMesaAddInType:
            number2 = value -> number;
            break;
        default:
            return 0;
        } // endswitch

        switch (operation) {
        case -2:
            return number2 < number;
        case -1:
            return number2 <= number;
        case 0:
            return number2 == number;
        case 1:
            return number2 >= number;
        case 2:
            return number2 > number;
        } // endswitch
    } else {
        char buf[257];
        const char *tmp = buf;

        switch (value -> type) {
        case errorValueMesaAddInType:
            return 0;
        case stringValueMesaAddInType:
            tmp = value -> string;
            break;
        case numberValueMesaAddInType:
            sprintf(buf,"%lf",value -> number);
            break;
        default:
            return 0;
        } // endswitch

        int res = strcmp(tmp,(criteria -> string)+stridx);
        switch (operation) {
        case -2:
            return  res < 0;
        case -1:
            return  res <= 0;
        case 0:
            return  res == 0;
        case 1:
            return  res >= 0;
        case 2:
            return  res > 0;
        } // endswitch
    } // endif

    return 0;
}





